import java.util.Scanner;
public class EsquemaRimatico {

	public static void rimar(int fatorRimatico, Scanner sc){
		String[] buffer = new String[25];
		String verso = sc.nextLine();
		int contadorVersos = 0;
		while (!verso.equals("")){
			buffer[contadorVersos] = verso;
			verso = sc.nextLine();
			contadorVersos++;
		}
		
		String[] poema = new String[contadorVersos];
		for (int i = 0; i < contadorVersos; i++){
			poema[i] = buffer[i];
		}
		
		if (fatorRimatico > 4 || fatorRimatico < 2){
			System.out.println("VALOR DE N INVALIDO!");
			return;
		}
		
		boolean[] passou = new boolean[poema.length];
		int[] esquemaRimatico = new int[poema.length];
		esquemaRimatico[0] = 1;
		passou[0] = true;
		int maior = 1;
		for (int k = 0; k < poema.length - 1; k++){
			String substring = poema[k].substring(poema[k].length() - fatorRimatico);
			
			for (int l = k + 1; l < poema.length; l++){
				String substring2 = poema[l].substring(poema[l].length() - fatorRimatico);
		
				if (substring.equals(substring2)){
					esquemaRimatico[l] = esquemaRimatico[k];
					passou[l]=true;
				}
				
				if (!substring.equals(substring2) && !passou[l]){
					if (maior < esquemaRimatico[k] + 1){
						maior = esquemaRimatico[k] + 1;
					}
					esquemaRimatico[l]= maior;
				}
			}
		}
		
		imprimir(esquemaRimatico);
	}
	
	private static void imprimir(int[] esquemaRimatico){
		for (int m = 0; m < esquemaRimatico.length; m++){
			char c = (char) (esquemaRimatico[m] + 64);
			if (m == esquemaRimatico.length - 1){
				System.out.print(c);
			}else{
				System.out.print(c + " ");
			}
		}
		System.out.println();
	}
	
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		
		int numCasos = Integer.parseInt(sc.nextLine());
		
		int i = 1;
		while (i <= numCasos){
			
			int fatorRimatico = Integer.parseInt(sc.nextLine());
			rimar(fatorRimatico, sc);
			i++;
			
		}
	}
}
